diff --git a/lisp/org-src.el b/lisp/org-src.el
index 75db1d7..064bf19 100644
--- a/lisp/org-src.el
+++ b/lisp/org-src.el
@@ -215,11 +215,19 @@ buffer."
     (setq org-edit-src-saved-temp-window-config (current-window-configuration)))
   (let* ((mark (and (org-region-active-p) (mark)))
 	 (case-fold-search t)
-	 (info (org-edit-src-find-region-and-lang))
+	 (info (let* ((first-pass (org-edit-src-find-region-and-lang))
+		      (first-pass-beg (nth 0 first-pass))
+		      (first-pass-end (nth 1 first-pass)))
+		 (if (< first-pass-end first-pass-beg)
+		     (progn
+		       (goto-char first-pass-beg)
+		       (insert "\n")
+		       (org-edit-src-find-region-and-lang))
+		   first-pass)))
 	 (full-info (org-babel-get-src-block-info 'light))
 	 (org-mode-p (derived-mode-p 'org-mode)) ;; derived-mode-p is reflexive
 	 (beg (make-marker))
-	 (end (make-marker))
+	 (end (copy-marker nil t))
 	 (allow-write-back-p (null code))
 	 block-nindent total-nindent ovl lang lang-f single lfmt buffer msg
 	 begline markline markcol line col transmitted-variables)
@@ -692,7 +700,8 @@ with \",*\", \",#+\", \",,*\" and \",,#+\"."
       (delete-region beg (max beg (1- end)))
       (unless (string-match "\\`[ \t]*\\'" code)
 	(insert code)
-	(delete-char 1))
+	(unless (= (point) end)
+	  (delete-char 1)))
       (goto-char beg)
       (if single (just-one-space)))
     (if (memq t (mapcar (lambda (overlay)
